#!/usr/bin/env python3

import subprocess
import re

def get_ppp_interfaces():
    result = subprocess.run(['ip', 'link'], stdout=subprocess.PIPE)
    output = result.stdout.decode('utf-8')
    interfaces = re.findall(r'ppp[0-9]+', output)
    return sorted(interfaces, key=lambda x: int(x[3:]))

def main():
    interfaces = get_ppp_interfaces()
    half_index_minus_one = (len(interfaces) // 2) - 1  # 计算接口数量的一半减1的位置索引

    with open('/root/speed.sh', 'w') as script_file:
        script_file.write("#!/bin/bash\n\n")
        for idx, iface in enumerate(interfaces):
            script_file.write(f"echo Running curl for interface {iface}\n")
            script_file.write(f"curl --interface {iface} https://eapi.jiasu123.net/bs/bdCoSpeed/deaab7633f2c636410b50f3be3b80f2a8190efa82e9f11141c12efcded2c841ff9f4e2d6ef420479f2200a02704a0393\n")
            if idx == half_index_minus_one:
                script_file.write("sleep 1000\n")
            else:
                script_file.write("sleep 5\n")

    print("Script /root/speed.sh has been created.")

if __name__ == "__main__":
    main()
